# ExaDrive VSCode Extension

The ExaDrive VSCode Extension is a powerful tool designed to help developers easily upload and manage their frontend static builds to ExaDrive's decentralized storage network.

## Features

- **Automatic Detection**: Automatically detects frontend build directories like `build`, `dist`, `www`, and `public`
- **Simple Configuration**: Configure your ExaDrive API Key and App ID directly from VSCode
- **One-Click Upload**: Upload your entire frontend build with a single command
- **File/Folder Selection**: Select specific files or folders to upload to any virtual path
- **Smart File Sync**: Only upload new or modified files to save bandwidth and time
- **File Management**: List, delete, and update files already uploaded to ExaDrive
- **CDN Support**: Toggle CDN delivery for your files with a simple command
- **Visual UI Panel**: Manage your ExaDrive files through an intuitive tree-based interface

## Getting Started

1. Install the extension from the Visual Studio Code Marketplace
2. Open your frontend project in VSCode
3. Configure your ExaDrive API Key and App ID by using the command palette (`Ctrl+Shift+P` or `Cmd+Shift+P`) and selecting "ExaDrive: Configure API Key and App ID"
4. After building your frontend application, use the command palette to select "ExaDrive: Upload Build Files"

## User Interface

The ExaDrive extension provides a dedicated panel in the Activity Bar:

1. Click the ExaDrive icon in the Activity Bar to open the panel
2. The panel displays all your files in a tree structure
3. For each file, you can:
   - Toggle CDN delivery with the "Enable CDN" or "Disable CDN" button
   - Delete files with the "Delete" button
4. Use the "Refresh" button to update the file list
5. Use the "Sync Files" button to synchronize your local files with ExaDrive

You can also access the panel by clicking on the ExaDrive status item in the footer.

## Commands

The extension provides the following commands:

- **ExaDrive: Configure API Key and App ID** - Set up your ExaDrive credentials
- **ExaDrive: Configure Sync Settings** - Configure build directory and target path for syncing
- **ExaDrive: Upload Build Files** - Upload all files from a build directory
- **ExaDrive: Select Files/Folders to Upload** - Select specific files or folders to upload to any virtual path
- **sync** - Intelligently sync files from configured build directory to specified target path
- **ExaDrive: List Uploaded Files** - View all files uploaded to ExaDrive
- **ExaDrive: Delete Uploaded Files** - Remove files from ExaDrive
- **ExaDrive: Toggle CDN for Files** - Enable or disable CDN delivery for selected files
- **ExaDrive: Open Panel** - Open the ExaDrive files panel

## Sync Configuration

To configure the sync functionality:

1. Use the command palette to select "ExaDrive: Configure Sync Settings"
2. Enter or browse to select the build directory relative to your workspace root
3. Specify the target path on ExaDrive where files should be uploaded
4. Save your settings

These settings are workspace-specific and will be remembered for this project.

## Uploading Specific Files or Folders

To upload specific files or folders:

1. Use the command palette to select "ExaDrive: Select Files/Folders to Upload"
2. Enter a virtual path where the files should be uploaded (e.g., `/images`, `/css`, or just `/` for the root)
3. Choose whether to select individual files or an entire folder
4. Browse and select the files or folder to upload
5. Confirm the upload when prompted

### 0.0.1

- Initial release of the ExaDrive extension
- Support for uploading, syncing, listing, and deleting files
- Automatic detection of common frontend build directories
- CDN toggle functionality for uploaded files
